;==============================================================================

; file: "_std#.scm"

; Copyright (C) 1994-2000 by Marc Feeley, All Rights Reserved.

;==============================================================================

; Error handling.

(##define-macro (macro-trap-list-lengths form)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  (if (list? form)
    `(##trap-list-lengths ',(car form) ,@(cdr form))
    `(##trap-list-lengths* ',(car form) ,@(flat (cdr form)))))

(##define-macro (macro-trap-list form)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  (if (list? form)
    `(##trap-list ',(car form) ,@(cdr form))
    `(##trap-list* ',(car form) ,@(flat (cdr form)))))

(##define-macro (macro-check-pair var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##pair? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-pair ',(car form) ,@(cdr form))
          `(##trap-check-pair* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-list-end var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##null? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-list ',(car form) ,@(cdr form))
          `(##trap-list* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-char var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##char? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-char ',(car form) ,@(cdr form))
          `(##trap-check-char* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-symbol var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##symbol? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-symbol ',(car form) ,@(cdr form))
          `(##trap-check-symbol* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-keyword var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##keyword? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-keyword ',(car form) ,@(cdr form))
          `(##trap-check-keyword* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-string var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##string? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-string ',(car form) ,@(cdr form))
          `(##trap-check-string* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-vector ',(car form) ,@(cdr form))
          `(##trap-check-vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-s8vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##s8vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-s8vector ',(car form) ,@(cdr form))
          `(##trap-check-s8vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-u8vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##u8vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-u8vector ',(car form) ,@(cdr form))
          `(##trap-check-u8vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-s16vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##s16vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-s16vector ',(car form) ,@(cdr form))
          `(##trap-check-s16vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-u16vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##u16vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-u16vector ',(car form) ,@(cdr form))
          `(##trap-check-u16vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-s32vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##s32vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-s32vector ',(car form) ,@(cdr form))
          `(##trap-check-s32vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-u32vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##u32vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-u32vector ',(car form) ,@(cdr form))
          `(##trap-check-u32vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-s64vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##s64vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-s64vector ',(car form) ,@(cdr form))
          `(##trap-check-s64vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-u64vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##u64vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-u64vector ',(car form) ,@(cdr form))
          `(##trap-check-u64vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-f32vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##f32vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-f32vector ',(car form) ,@(cdr form))
          `(##trap-check-f32vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-f64vector var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##f64vector? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-f64vector ',(car form) ,@(cdr form))
          `(##trap-check-f64vector* ',(car form) ,@(flat (cdr form)))))
     ,expr))

(##define-macro (macro-check-procedure var form expr)
  (define (flat x) (if (pair? x) (cons (car x) (flat (cdr x))) (list x)))
  `(macro-if-checks
     (if (##procedure? ,var)
       ,expr
       ,(if (list? form)
          `(##trap-check-procedure ',(car form) ,@(cdr form))
          `(##trap-check-procedure* ',(car form) ,@(flat (cdr form)))))
     ,expr))

;==============================================================================
